#ifndef _MPSYSTEM_H_
#define _MPSYSTEM_H_

// castica systemu
typedef struct _Particle {
 GLfloat X,Y,Z;    // X,Y,Z suradnice polohy castice
 GLfloat dX,dY,dZ; // zmena polohy v danom smere
 GLfloat R,G,B;    // farba castice
};

// ohnostroj
typedef struct _Firework {
 GLfloat X,Y,Z;          // X,Y,Z suradnice polohy ohnostroja
 GLfloat dX,dY,dZ;       // zmena polohy v danom smere

 GLfloat StartTime;      // start "zivota" ohnostroja
 GLfloat StopTime;       // koniec "zivota" ohnostroja

 GLfloat ExplosionStart; // start "zivota" explozie
 GLfloat ExplosionTime;  // dlzka "zivota" explozie
 GLuint ExplosionType;   // typ explozie

 _Particle Rocket[8];    // 8 castic pre strelu
 _Particle Expl[64];     // 64 castic pre exploziu
};

// trieda premennych a funkcii pre pracu s OpenGL particle systemom
class mPSystem {
public:
 mPSystem();          // konstruktor
 virtual ~mPSystem(); // destruktor

 void SetFireworksNum(GLuint FN);      // nastavenie poctu aktivnych ohnostrojov
 void SetTime(GLfloat AT,GLfloat FPS); // nastavenie aktualneho casu

 void FireworkSetup(GLuint N); // pociatocne nastavenie parametrov ohnostroja

 void FireworksDraw(void); // vykreslenie vsetkych aktivnych ohnostrojov
private:
 _Firework Firework[10]; // ohnostroje
 GLuint FireworksNum;    // pocet aktivnych ohnostrojov, max. 10!

 GLfloat ActualTime,Fps,T1; // pre pracu s casom

 GLuint i,j; // pomocne premenne
 GLfloat ii; // pomocna premenna

 GLfloat RM,R,R1,R2,R3; // pre ulozenie RAND_MAX a nahodnych cisiel

 GLfloat fade; // utlm

 // ziskanie nahodneho cisla v intervale start-stop
 GLfloat get_random_number(GLfloat start,GLfloat stop);

 void FireworkRocket(GLuint N);  // vyvoj "zivota" strely
 void FireworkExplode(GLuint N); // vyvoj "zivota" explozie
};

#endif
